## mingw-w64-roswell-24.10.115-1.src.tar.zst

=== scripts/Makefile ===
-include .env
export $(shell sed 's/=.*//' .env)

DOCKER_REPO ?= docker.pkg.github.com/roswell/roswell
DOCKER_PLATFORM ?= linux/amd64
DOCKER_BUILD_OPTIONS ?=
DOCKER_IMAGE_SUFFIX ?=
IMAGE ?=

all:
	echo all

latest-version:
	$(eval VERSION := $(shell grep AC_INIT configure.ac|sed 's/.*\[\(.*\)\].*/\1/'))
#'
checkout:
	if [ ! "v$(VERSION)" = "v" ];then \
		git checkout v$(VERSION); \
	fi

show:
	@echo VERSION=$(VERSION) VARIANT=$(VARIANT)

build-docker:
	docker build \
		--platform $(DOCKER_PLATFORM) \
		-t $(DOCKER_REPO)/$$(cat ./scripts/Docker/$(IMAGE)/Name)$(DOCKER_IMAGE_SUFFIX) \
		$(DOCKER_BUILD_OPTIONS) \
		./scripts/Docker/$(IMAGE)
push-docker:
	docker push $(DOCKER_REPO)/$$(cat ./scripts/Docker/$(IMAGE)/Name)$(DOCKER_IMAGE_SUFFIX);
pull-docker:
	docker pull $(DOCKER_REPO)/$$(cat ./scripts/Docker/$(IMAGE)/Name)$(DOCKER_IMAGE_SUFFIX);
docker:
	docker run \
		--rm \
		--platform $(DOCKER_PLATFORM) \
		-v `pwd`:/tmp2 \
		-e ARCH=$(ARCH) \
		-e VERSION=$(VERSION) \
		-e SUFFIX=$(SUFFIX) \
		-e CFLAGS=$(CFLAGS) \
		-e LINKFLAGS=$(LINKFLAGS) \
		-e VARIANT=$(VARIANT) \
		$(DOCKER_REPO)/$$(cat ./scripts/Docker/$(IMAGE)/Name)$(DOCKER_IMAGE_SUFFIX) \
		bash \
		-c "cd /tmp2;make -f scripts/Makefile $(MAKEOPTS)"
upload:
	echo upload!!! $(FILE)
	ros install roswell/sbcl_bin
	ros -s roswell.github.utils -e "(mapc (lambda (x) (print x) (roswell.github.utils:github x \"v$(VERSION)\" \"roswell\" \"roswell\")) (directory \"$(FILE)\"))"

musl:
	./bootstrap
	./configure --enable-maintainer-mode --with-sbcl-bin-variant=$(VARIANT) \
	LDFLAGS="--static -static-libgcc -static-libstdc++ -static" \
	LIBS="-lcurl -lbrotlidec -lbrotlicommon -lnghttp2 -lssl -lcrypto -lz -lzstd -lcares -lidn2 -lunistring -lpsl"
	make
	make pack

musl-upload:
	env FILE=`echo roswell*.tar.bz2` VERSION=$(VERSION) $(MAKE) -f $(realpath $(firstword $(MAKEFILE_LIST))) upload

deb:
	pwd
	ls -al
	./bootstrap
	./configure
	make
	make debian
	cp debian/debian/*.deb .

deb-upload:
	env FILE=`echo *.deb` VERSION=$(VERSION) $(MAKE) -f $(realpath $(firstword $(MAKEFILE_LIST))) upload

docs:
	rm -f documents/man/* documents/html/*
	./bootstrap
	./configure --enable-manual-generation --enable-html-generation
	make

docs-upload:
	git config --local user.email "auto@example.com"
	git config --local user.name "github actions"
	git branch
	git status
	git add -u
	git add documents/man/* documents/html/*
	(git commit -m "[ci skip] documents update" && git push origin $$(git rev-parse --abbrev-ref HEAD)) || true

upload.exe:
	curl --no-progress-bar --retry 10 -o upload.tar.bz2 -L https://github.com/roswell/roswell/releases/download/v21.06.14.110/upload-mingw64_nt-x86_64.tar.bz2
	tar xvf upload.tar.bz2

win-upload: upload.exe
	env FILE=`echo roswell*.zip` VERSION=v$(VERSION) OWNER=roswell REPO=roswell ./upload.exe
	env FILE=`echo roswell*.hash` VERSION=v$(VERSION) OWNER=roswell REPO=roswell ./upload.exe

.PHONY: all latest-version checkout show build-docker pull-docker docker upload musl

=== t/tree-shaker/Makefile ===

# .SECONDEXPANSION:

pop = $(filter-out $(firstword $(1)), $(1))

# $(info a b c)
# $(info $(strip a b c))
# $(info $(firstword $(strip a b c)))
# $(info $(call pop,$(strip a b c)))
# $(info a b c)

c_dump = ros dump                       $(call pop,$(1)) executable aaa.ros -o $(firstword $(1))
u_dump = ros dump --disable-compression $(call pop,$(1)) executable aaa.ros -o $(firstword $(1))

targets = baseline docstring destroy package packages except debug compiler macro cmacro combined

.PHONY: $(targets) all clean test

all: $(targets)
	ls -lh *.bin
# somehow this does not work
# %: u-%.bin c-%.bin
# %.dep: u-%.bin c-%.bin

baseline:	 u-baseline.bin  c-baseline.bin
docstring:	 u-docstring.bin c-docstring.bin
#destroy:	 u-destroy.bin   c-destroy.bin
package:	 u-package.bin   c-package.bin
packages:	 u-packages.bin  c-packages.bin
except:          u-except.bin    c-except.bin
debug:	         u-debug.bin     c-debug.bin
compiler:	         u-compiler.bin     c-compiler.bin
macro:	         u-macro.bin     c-macro.bin
cmacro:	         u-cmacro.bin     c-cmacro.bin
#combined:        u-combined.bin  c-combined.bin


dump = $(call $(firstword $(subst -, ,$@))_dump, $@ $(1))

%-baseline.bin  : aaa.ros
	$(call dump)
	./$@
%-docstring.bin : aaa.ros
	$(call dump, --remove-docstrings)
	./$@
%-destroy.bin   : aaa.ros
	$(call dump, --destroy-packages-sbcl)
	./$@
%-package.bin  : aaa.ros
	$(call dump, --delete-package trivia)
	./$@
%-packages.bin  : aaa.ros
	$(call dump, --delete-all-packages)
	./$@
%-except.bin    : aaa.ros
	$(call dump, --delete-packages-except trivia)
	./$@
%-debug.bin    : aaa.ros
	$(call dump, --delete-debug-info)
	./$@
%-compiler.bin    : aaa.ros
	$(call dump, --delete-compiler-information-sbcl)
	./$@
%-macro.bin    : aaa.ros
	$(call dump, --delete-macro-definitions)
	./$@
%-cmacro.bin    : aaa.ros
	$(call dump, --delete-compiler-macro-definitions)
	./$@
%-combined.bin    : aaa.ros
	$(call dump, --remove-docstrings --delete-debug-info \
                     --delete-macro-definitions --delete-compiler-macro-definitions \
                     --delete-compiler-information-sbcl \
                     --delete-all-packages --destroy-packages-sbcl)
	./$@

test:
	for bin in *.bin ; do echo "$$bin        $$(./$$bin)" ; done

clean:
	rm -f *.bin

=== PKGBUILD ===
# Maintainer: SANO Masatoshi <snmsts@gmail.com>
_realname=roswell
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=24.10.115
pkgrel=1
pkgdesc="Lisp installer and launcher (mingw-w64)"
url="https://github.com/roswell/roswell"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
license=("spdx:MIT")
depends=()
makedepends=("${MINGW_PACKAGE_PREFIX}-autotools"
             "${MINGW_PACKAGE_PREFIX}-cc")
optdepends=()
source=("https://github.com/roswell/roswell/archive/v$pkgver.tar.gz")
sha256sums=('9c23cb263d4645caaae21cda8f1f5793b0f08ee5c5338aab5974cb4f473d1c4b')

build() {
  cd "${srcdir}"/${_realname}-${pkgver}
  ./bootstrap
  ./configure \
    --prefix=${MINGW_PREFIX} \
    --build=${MINGW_CHOST} \
    --host=${MINGW_CHOST} \
    --target=${MINGW_CHOST} \

  make
}

package() {
  cd "${_realname}-$pkgver"

  make install DESTDIR="${pkgdir}"

  install -Dm644 COPYING "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"

}

=== debian/control ===
Source: roswell
Section: lisp
Priority: optional
Maintainer: Masatoshi SANO <snmsts@gmail.com>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Homepage: https://github.com/roswell/roswell
Vcs-Git: https://github.com/roswell/roswell.git

Package: roswell
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, bzip2 , make
Description: <insert up to 60 chars description>
 <insert long description, indented with spaces>
